function [facc, n_LV,yhat, fspec, fsens] = MFC_crossvalidate_DAMACY_top_fusion(C, Labels, trainset, testset, ppmodes, pc_used, paired_data,DAMACY_settings)
%%

%% create training and test set
n_iterations = size(trainset,2); % number of iterations
n_repeats = sum(testset(1,:),2);
n_folds = n_iterations/n_repeats;
acc = zeros(1,n_iterations);
spec = zeros(1,n_iterations);
sens = zeros(1,n_iterations); 
n_LV = zeros(n_iterations,1);
yhat = zeros(length(C{1}),n_repeats);
for l1 = 1:n_iterations
    C = cellfun(@(a) trainsetinStruct(a,trainset(:,l1), testset(:,l1)), C, 'uniformoutput', false);
    C_scaled = cellfun(@(a,b) Pre_process_MFC_takingintoaccountthenumberofcells(a,paired_data,b), C, ppmodes, 'uniformoutput', false);
    [DAMACY_output] = DAMACY_top_fusion(C_scaled, Labels, pc_used, DAMACY_settings); 
    acc(l1) = DAMACY_output.accuracy;
    n_LV(l1) = DAMACY_output.OPLS_model.n_LV;
    yhat(testset(:,l1),ceil(l1/n_folds)) = DAMACY_output.yhat;
    spec(l1) = DAMACY_output.spec;
    sens(l1) = DAMACY_output.sens; 
end
facc = sum(acc.*sum(testset,1))/length(C{1});
fspec = sum(sum(testset(~logical(Labels),:)).*spec)/sum(sum(testset(~logical(Labels),:)));
fsens = sum(sum(testset(logical(Labels),:)).*sens)/sum(sum(testset(logical(Labels),:)));
end