function [yhat_svm,  yhat_opls, n_LV, yhat_glmnet, lambda] = SOMSVM(S, trainset)
%%

%%
nr_samples = length(S);
H = zeros(nr_samples,100);
Labels = vertcat(S.Labels);
yhat_svm = cell(size(trainset,2),1);
yhat_opls = cell(size(trainset,2),1);
yhat_glmnet = cell(size(trainset,2),1);
n_LV = zeros(size(trainset,2),1);
lambda = zeros(size(trainset,2),1);
testset = ~trainset;
Y2 = Labels == 0;
Y1 = ~Y2;
Y = Y1 - Y2;
for l1 = 1:size(trainset,2)
    [S] = trainsetinStruct(S,trainset(:,l1), testset(:,l1)); %Add train field to struct
    [S_scaled] = Pre_process_MFC_takingintoaccountthenumberofcells(S, 0, [4;2;1]);
    X = vertcat(S_scaled(trainset(:,l1)).Data);
    %     [a,w]  = som(X, 10, size(X,1)*10);
    %     a_vector = a(:);
    %     a_data = X(a,:);
    [sMap,D] = som_make(X, 'msize', [10 10], 'training', [10 10]);
    for l2 = 1:nr_samples
        Idx = knnsearch(sMap.codebook,S_scaled(l2).Data);
        single_hist = accumarray(Idx,1);
        H(l2,1:length(single_hist)) = single_hist;
    end
    H_cs = (H - mean(H(trainset(:,l1),:)))./std(H(trainset(:,l1),:));
    SVMModel = fitcsvm(H_cs(trainset(:,l1),:),Labels(trainset(:,l1)));
    yhat_svm{l1} = H_cs(~trainset(:,l1),:)*SVMModel.Beta + SVMModel.Bias;
    [B,FitInfo] = lassoglm(H_cs(trainset(:,l1),:),Labels(trainset(:,l1)),'binomial', 'CV', 10);
    yhat_glmnet{l1} = H_cs(~trainset(:,l1),:)*B(:,FitInfo.IndexMinDeviance) + FitInfo.Intercept(FitInfo.IndexMinDeviance);
    lambda(l1) = FitInfo.LambdaMinDeviance; 
    [b_acc, n_LV(l1)] = Damacy_top_cv_acc_lvonly(H_cs(trainset(:,l1),:), Y(trainset(:,l1)), 15);
    [w,~,p,    q,~,P_o,W_o] = OPLS(H_cs(trainset(:,l1),:),Y(trainset(:,l1)),n_LV(l1));
    [~,~,yhat_opls{l1}] = OPLSpred(H_cs(~trainset(:,l1),:),P_o,W_o,w,q,n_LV(l1));
end
