function [yhat_svm,  yhat_opls, yhat_glmnet] = SOMSVM_perm(S, trainset, R, n_LV, lambda)
%%

%%
nr_samples = length(S);
H = zeros(nr_samples,100);
Labels = vertcat(S.Labels);
yhat_svm = cell(size(trainset,2),1);
yhat_opls = cell(size(trainset,2),1);
yhat_glmnet = cell(size(trainset,2),1);
testset = ~trainset;
Y2 = Labels == 0;
Y1 = ~Y2;
Y = Y1 - Y2;
for l1 = 1:size(trainset,2)
    [S] = trainsetinStruct(S,trainset(:,l1), testset(:,l1)); %Add train field to struct
    [S_scaled] = Pre_process_MFC_takingintoaccountthenumberofcells(S, 0, [4;2;1]);
    X = vertcat(S_scaled(trainset(:,l1)).Data);
    %     [a,w]  = som(X, 10, size(X,1)*10);
    %     a_vector = a(:);
    %     a_data = X(a,:);
    [sMap,D] = som_make(X, 'msize', [10 10], 'training', [10 10]);
    for l2 = 1:nr_samples
        Idx = knnsearch(sMap.codebook,S_scaled(l2).Data);
        single_hist = accumarray(Idx,1);
        H(l2,1:length(single_hist)) = single_hist;
    end
    H_cs = (H - mean(H(trainset(:,l1),:)))./std(H(trainset(:,l1),:));
    for l4 = 1:1000
        Yperm = Y(R(:,l4));
        Labels_perm = Labels(R(:,l4));
    SVMModel = fitcsvm(H_cs(trainset(:,l1),:),Labels_perm(trainset(:,l1)));
    yhat_svm{l1,l4} = H_cs(~trainset(:,l1),:)*SVMModel.Beta + SVMModel.Bias;
    [B,FitInfo] = lassoglm(H_cs(trainset(:,l1),:),Labels_perm(trainset(:,l1)),'binomial', 'lambda', lambda);
    yhat_glmnet{l1,l4} = H_cs(~trainset(:,l1),:)*B + FitInfo.Intercept;
    [w,~,p,    q,~,P_o,W_o] = OPLS(H_cs(trainset(:,l1),:),Yperm(trainset(:,l1)),n_LV);
    [~,~,yhat_opls{l1,l4}] = OPLSpred(H_cs(~trainset(:,l1),:),P_o,W_o,w,q,n_LV);
    end
    toc
end
