function plot_som_pie_kamada(codebook, B, V,single_hist)
%%
% fun
%%

codebook2 = codebook-min(codebook); %substracts the lowest value, lowest value does not get a part in the pie
colors = distinguishable_colors(size(codebook2,2),[1 1 1; 0 0 0; linspace(0,1,64)' zeros(64,2); zeros(64,2) linspace(0,1,64)']); %find distinguisable colors

mst_map = mst(codebook);
node_positions = kamada_kawai_spring_layout(mst_map);
gplot(mst_map,node_positions)
hold on
if ~isempty(B)
w = B/max(max([B, abs(B)])); %/.1; %.025;%
w(w>1) = 1; 
w(w<-1) = -1; 
end
for l1 = 1:size(codebook2,1)
    if ~isempty(B)
    if w(l1) < 0
        filledCircle(node_positions(l1,:),1,1000,'r', -w(l1));
    else
        filledCircle(node_positions(l1,:),1,1000,'b', w(l1));
    end
    end
    X_tmp = codebook2(l1,:);
    p=pie(X_tmp);
    if ~isempty(single_hist);
         sc = sqrt(single_hist(l1))*0.01; % <scaling factor (different for each city)
    else
     sc = .5;
    end
    % Loop through each slice of the pie:
    count = 0;
    idx = find(codebook2(l1,:)); %find all positive values in codebook2
    for k = 1:2:length(p)
        count = count + 1;
        % x,y coordinates of a slice:
        tmp = p(k).Vertices;
        % Scale the size of the slice:
        tmp = tmp*sc;
        % Place the center of the pie on its city:
        tmp(:,1) = tmp(:,1)+node_positions(l1,1);
        tmp(:,2) = tmp(:,2)+node_positions(l1,2);
        patch(tmp(:,1),tmp(:,2),colors(idx(count),:)); % <-specify the color you want
    end
    delete(p)
    
end

h2 = [];
for l1 = 1:size(colors,1)
    h2(l1) = plot(NaN(1), NaN(1),'s', 'color', colors(l1,:), 'MarkerFaceColor', colors(l1,:));
end
legend(h2, V)
set(gca, 'fontsize', 16, 'xtick', [], 'ytick', [])