function yhat_svm = crossvalidate_DAMACY_base_fusion_svm_permutation(C,trainset,testset, ppmodes, pc_used,DAMACY_settings, R)
%%

%%
binsize = DAMACY_settings.binsize;
if isfield(DAMACY_settings, 'paired_data')
    paired_data = DAMACY_settings.paired_data;
else
    paired_data = 0;
end
yhat_svm = cell(size(trainset,2),size(R,2));
n_iterations = size(trainset,2); % number of iterations
Labels = vertcat(C{1}.Labels);
for l0 = 1:n_iterations
    C = cellfun(@(a) trainsetinStruct(a,trainset(:,l0), testset(:,l0)), C, 'uniformoutput', false);
    C_scaled = cellfun(@(a,b) Pre_process_MFC_takingintoaccountthenumberofcells(a,paired_data,b), C, ppmodes, 'uniformoutput', false);
    %%
    N_PCs = length(pc_used);
    X = cellfun(@blockscale_struct, C_scaled, 'uniformoutput', false);
    [~, LDS] = cellfun(@pcafunction, X, 'uniformoutput', false);
    
    %% Project data
    % Time 0.3
    number_samples = length(C_scaled{1});
    number_sets = length(C_scaled);
    C_scores = C_scaled;
    for l1 = 1:number_sets
        for l2 = 1:number_samples
            C_scores{l1}(l2).Data = C_scaled{l1}(l2).Data*LDS{l1}(:,pc_used{l1});
        end
    end
    
    X = cellfun(@(a) vertcat(a(trainset(:,l0)).Data),C_scores, 'uniformoutput', false);
    edges = cellfun(@(a) binedges(a, [binsize], 0.01, 1), X, 'uniformoutput', false);
    
    %% Create Histograms
    % Time: 90 seconds
    
    X = [];
    Histograms = zeros([number_samples binsize]);
    for l2 = 1:number_sets
        for l1 = 1:number_samples
            Histograms(l1,:,:,:,:,:,:) = NDhist(C_scores{l2}(l1).Data, edges{l2}, 5);
        end
        X = [X reshape(Histograms,number_samples, prod(binsize))];
    end
    
    %% remove empty bins (DAMACY)
    %Note: Empty bins should not be taken into account to circumvent seperation
    %based on empty vs not empty. The empty bins are not 0, but have a very low
    %value due to the smoothing.
    ind = std(X) > 10^-6;
    % X1 = X1/sqrt(sum(X1(:).^2));
    % X2 = X2/sqrt(sum(X2(:).^2));
    % X = [X1 X2];
    X = X(:,ind);
    
    H_cs = (X - mean(X(trainset(:,l0),:)))./std(X(trainset(:,l0),:));
    for l3 = 1:size(R,2)
        Labels_perm = Labels(R(:,l3));
        SVMModel = fitcsvm(H_cs(trainset(:,l0),:),Labels_perm(trainset(:,l0)));
        yhat_svm{l0,l3} = H_cs(~trainset(:,l0),:)*SVMModel.Beta + SVMModel.Bias;
    end
end