function [yhat_svm, yhat_glmnet, lambda] = crossvalidate_DAMACY_base_lasso_svm(S,trainset,testset, pre_process_modes, pc_used,DAMACY_settings)
%%
% Function performs SVM and generalized linear model with lasso
% regularization

%%
if isfield(DAMACY_settings, 'paired_data')
    paired_data = DAMACY_settings.paired_data;
else
    paired_data = 0; 
end
Labels = vertcat(S.Labels);
yhat_svm = cell(size(trainset,2),1);
yhat_glmnet = cell(size(trainset,2),1);
lambda = zeros(size(trainset,2),1);
n_iterations = size(trainset,2); % number of iterations
for l1 = 1:n_iterations
    [S] = trainsetinStruct(S,trainset(:,l1), testset(:,l1)); %Add train field to struct
    [S_scaled] = Pre_process_MFC_takingintoaccountthenumberofcells(S, paired_data, pre_process_modes);
    [~, Histograms, ~] = DAMACY_base(S_scaled,paired_data, DAMACY_settings, pc_used);
    X = reshape(Histograms, size(Histograms,1), prod(DAMACY_settings.binsize));
    ind = std(X) > 10^-6;
    X = X(:,ind);
    H_cs = (X - mean(X(trainset(:,l1),:)))./std(X(trainset(:,l1),:));
    SVMModel = fitcsvm(H_cs(trainset(:,l1),:),Labels(trainset(:,l1)));
    yhat_svm{l1} = H_cs(~trainset(:,l1),:)*SVMModel.Beta + SVMModel.Bias;
%     [B,FitInfo] = lassoglm(H_cs(trainset(:,l1),:),Labels(trainset(:,l1)),'binomial', 'CV', 10);
%     yhat_glmnet{l1} = H_cs(~trainset(:,l1),:)*B(:,FitInfo.IndexMinDeviance) + FitInfo.Intercept(FitInfo.IndexMinDeviance);
%     lambda(l1) = FitInfo.LambdaMinDeviance; 
end