function PCAtop_clean(Histograms, Labels, ID)
%%
% Function performs Principle Component Analysis on the histograms
%
% Input
% Histograms n x 500 x 500 matrix with n being the number of samples
% Labels n x 1 matrix with the Labels
% ID n x 1 matrix with the ID
%
% Output
% PCA plot
%
% Written by G.H. Tinnevelt at Radboud University on 2 March 2016
%%

X = Histograms(:,:);
mean_X = mean(X);
X2 = X - repmat(mean_X,size(X,1), 1);

[SCR, LDS, VARp]=pcafunction(X2);
figure; 
plot_biplot(SCR, LDS, VARp, [], [1 2],[], Labels)
text(SCR(:,1)+1*10^-4,SCR(:,2), ID, 'fontsize', 23)
set(gca, 'Xtick', [], 'Ytick', [])

%%