    function [headername]=create_csv_files(model, S, S_scaled, VariableNames)
%%
%
% Function to create csv file from every datafile
%
% Input
% model; Either a DAMACY, or ECLIPSE/FLOOD control/response model
% S struct
% S_scaled struct
% VariableNames
%
% Written by G.H. Tinnevelt on 1 February 2016 at Radboud University
%%
location = uigetdir; 
headername = VariableNames'; %create the VariableNames plus PC names as header
for l2 = 1:size(S_scaled(1).Data,2)
    headername = [headername {['PC' num2str(l2)]}];
end
if isfield(S, 'weights')
    headername = [headername 'Damacy weights'];
end
for l1 = 1:length(S_scaled)
    if isfield(model, 'PCAloading')
        SCR = S_scaled(l1).Data*model.PCAloading; 
    elseif isfield(model, 'Pc')
        SCR = S_scaled(l1).Data*model.Pc; 
    elseif isfield(model, 'Pp')
        SCR = S_scaled(l1).Data*model.Pp; 
    elseif isfield(model, 'loadings')
        SCR = S_scaled(l1).Data*model.loadings;
    end
    Data = [S(l1).Data SCR]; 
    if isfield(S, 'weights')
        Data = [Data S(l1).weights];
    end
    filename = [location '\' 'TfL_cofactor99th_ ' num2str(S_scaled(l1).IDs) '.csv'];
    csvwrite(filename, Data);
    
    fid = fopen(filename, 'w') ;
    fprintf(fid, '%s,', headername{1,1:end-1}) ;
    fprintf(fid, '%s\n', headername{1,end}) ;
    fclose(fid) ;
    dlmwrite(filename, Data, '-append') ;
end
    

