function [A,C] = plot_CI_hull(CH, edges, color_id)
%%
%Input:
%       CH = confidense hull matrix (mask)
%       edges = edges defined by the histogram function being edges(1,:)
%       the first dimension and edges(2,:) the second dimension.
%       color_id = the color you want the border to have
%
% To use:
% first plot histogram with edges
% figure;
% imagesc(edges(1,:), edges(2,:), Histogram)
% hold on;
% plot_CI_hull(CH, edges, [0 1 1]); (for cyan line)
%
% written by Gerjen Tinnevelt and Dillen Augenstein 26-1-2015
% edited by Gerjen Tinnevelt at 25-2-2015 (added color input)
%%
[ind(:,1),ind(:,2)] = find(CH == 1);
[~,S]=alphavol(ind,sqrt(2));
A=ind((S.bnd(:,1)),:);

B=false(size(A,1),1);
C{1}=[];
CurrI=1;
rondje=1;
for I=2:size(A,1);
    B(CurrI)=true;
    D(~B)=sqrt((A(~B,1)-A(CurrI,1)).^2 + (A(~B,2)-A(CurrI,2)).^2 )  ;
    D(B)=inf;
    [dist,index] = min(D);
    if dist<8;
        C{rondje}(end+1)=[index];
        CurrI=index;
    else
        
        C{rondje}(end+1)=C{rondje}(1);
        rondje=rondje+1;
        CurrI=index;
        C{rondje}=[];
        C{rondje}(end+1)=index;
    end
end
% figure; hold all;
for I=1:rondje;
    if length(C{I}) > 30
        A2=A(C{I},:);
        plot(edges(1,A2(:,1)),edges(2,A2(:,2)), 'color', color_id, 'linewidth', 3)
    end
end